<?php

namespace WebsiteBundle\Controller\Site;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use WebsiteBundle\Form\Site\ContactUsType;

class ContactUsController extends Controller
{
  public function indexAction(Request $request) {
    $form = $this->createForm(ContactUsType::class);
    $form->handleRequest($request);

    if ($form->isValid() && $form->isSubmitted()) {

      $emailService = $this->get('WebsiteBundle.services.EmailService');
      $emailService->sendContactUsEmail($form->getData());

      $translator = $this->get('translator');
      $message = $translator->trans('site.emails.contactUs.messageSent');
      $this->addFlash('success', $message);
    }

    $templateData = [
      'form' => $form->createView(),
      'headerTitle' => 'CONTACT'
    ];

    return $this->render('@Website/ContactUs/contactUs.html.twig', $templateData);
  }

}
