<?php

namespace WebsiteBundle\Form\Admin;

use Bazookas\AdminBundle\Form\Type\EntityPickerType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use WebsiteBundle\Entity\Test;

class TestAdminType extends AbstractType
{

  /**
   * @param FormBuilderInterface $builder
   * @param array $options
   */
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $builder
      ->add('name', TextType::class, [
        'label' => 'admin.entities.test.fields.name'
      ])
      ->add('type', ChoiceType::class, [
        'label' => 'admin.entities.test.fields.type',
        'choices' => [
          'admin.entities.test.enums.TYPE_PASAT' => Test::TYPE_PASAT,
          'admin.entities.test.enums.TYPE_APASAT' => Test::TYPE_APASAT,
          'admin.entities.test.enums.TYPE_CONTROL' => Test::TYPE_CONTROL,
        ],
        'disabled' => $builder->getData()->getId() !== null
      ])
      ->add('tutorialText', TextareaType::class, [
        'label' => 'admin.entities.test.fields.tutorialText'
      ])
    ;
  }

  /**
   * @param OptionsResolver $resolver
   */
  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults([
      'data_class' => Test::class,
      'translation_domain' => 'admin'
    ]);
  }
}
