<?php

namespace WebsiteBundle\Form\Site;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\EmailType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Validator\Constraints\Email;
use Symfony\Component\Validator\Constraints\NotBlank;

class ContactUsType extends AbstractType
{

  /**
   * @param FormBuilderInterface $builder
   * @param array $options
   */
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $builder
      ->add('name', TextType::class, [
        'label' => 'site.forms.contactUs.fields.name',
        'constraints' => new NotBlank()
      ])
      ->add('email', EmailType::class, [
        'label' => 'site.forms.contactUs.fields.email',
        'constraints' => [
          new NotBlank(),
          new Email()
        ]
      ])
      ->add('phoneNumber', TextType::class, [
        'label' => 'site.forms.contactUs.fields.phoneNumber',
        'required' => false
      ])
      ->add('text', TextareaType::class, [
        'label' => 'site.forms.contactUs.fields.text',
        'constraints' => new NotBlank()
      ])
      ->add('submit', SubmitType::class, [
        'label' => 'site.forms.contactUs.fields.submit'
      ])
    ;
  }

  /**
   * @param OptionsResolver $resolver
   */
  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults([
      'csrf_protection' => false
    ]);
  }
  
}
