var bazookas = bazookas || {};

bazookas.libraries = (function () {
  var self = {},
    language,
    now;

  var slideCount = 1;
  var sendAjax = false;
  var data = {};
  var url = $('.psychoQuestions').data('url');
  var survey = $('.psychoQuestions').data('survey');
  var $exampleButton = $('.js-hide-example');
  var validated = false;

  self.init = function (context) {
    $('.psychoQuestions').slick({
      arrows: false,
      draggable: false,
      infinite: false,
      adaptiveHeight: true
    });
    $('.js-next-slide').on('click', nextSlideClickHandler);
    $exampleButton.on('click', hideExampleClickHandler);
    setAccordion();
    $('.response input').on('change', checkAmountSelected);
    if ($('#survey').length > 0) {
      // Create IE + others compatible event handler
      var eventMethod = window.addEventListener ? "addEventListener" : "attachEvent";
      var eventer = window[eventMethod];
      var messageEvent = eventMethod == "attachEvent" ? "onmessage" : "message";

      // Listen to message from child window
      eventer(messageEvent, function (e) {
        if (e.data === 'complete_survey') {
          $('#surveyDone').removeClass('dissabled');
          $('#survey').hide();

          window.location = $('#surveyDone').attr('href');
        }
      }, false);
    }
    if ($('#backToTop').length > 0) {
      //Check to see if the window is top if not then display button
      $(window).scroll(function () {
        if ($(this).scrollTop() > 100) {
          $('#backToTop').fadeIn();
        } else {
          $('#backToTop').fadeOut();
        }
      });

      //Click event to scroll to top
      $('#backToTop').click(function () {
        $('html, body').animate({scrollTop: 0}, 800);
        return false;
      });
    }
  };

  function hideExampleClickHandler(e) {
    $('.example').removeClass('show');
    $('.real__test').removeClass('show');

    setTimeout(function () {
      $('.example').hide();
      $('.real__test').hide();
      $('.game').addClass('show');
      $('.game').show();

    }, 500);
  }

  function nextSlideClickHandler(e) {

    if (checkAmountSelected()) {
      $('.js-next-slide').addClass('disabled');
    } else {
      if (validated) {
        $('.psychoQuestions').slick('slickNext');
        $('.js-next-slide').text('Volgende');


        if (sendAjax) {
          collectSelectedAnswers();
        }

        slideCount++;
        validated = false;
      } else {
        var allInputs = $('.slick-active .response input');

        for (var i = 0; i < allInputs.length; i++) {
          var response = allInputs[i];
          var $response = $(response);

          //prevent the user from changing their answer
          $response.prop('disabled', 'disabled');

          if (response.checked) {
            var $parent = $response.parent();
            if($response.data('correct') == false){
              $parent.addClass('wrong');
              $parent.find('.incorrect__reason').show();
            }else{
              $parent.addClass('right');
            }
          }
        }

        validated = true;
      }
    }
    checkAmountSelected();
  }

  function setAccordion() {
    var acc = document.getElementsByClassName("accordion");
    var i;

    for (i = 0; i < acc.length; i++) {
      acc[i].onclick = function () {
        this.classList.toggle("active");
        var panel = this.nextElementSibling;
        if (panel.style.maxHeight) {
          panel.style.maxHeight = null;
        } else {
          panel.style.maxHeight = panel.scrollHeight + "px";
        }
      }
    }
    $('.accordionControl').on('click', toggleAllAccordionsClickHandler);

  }

  function toggleAllAccordionsClickHandler(e) {
    $(e.currentTarget).toggleClass('active');
    $('.accordion').trigger('click');
  }


  function collectSelectedAnswers() {
    var $responses = $('.response input');

    var answers = [];
    for (var i = 0; i < $responses.length; i++) {
      var $response = $responses[i];
      if ($response.checked) {
        var panelId = $($response).data('panel');
        var responseId = $($response).data('id');

        for (var ii = 0; ii < answers.length; ii++) {
          var dataObj = answers[ii];
          var panelIdFound = false;
          if (dataObj.panelId == panelId) {
            panelIdFound = true;
            var found = false;
            for (var iii = 0; iii < dataObj.responseIds.length; iii++) {
              var respId = dataObj.responseIds[iii];
              if (respId == responseId) {
                found = true;
              }
              if (!found) {
                dataObj.responseIds.push(responseId);
              }
            }
          }

        }
        if (!panelIdFound) {
          answers.push({
            panelId: panelId,
            responseIds: [responseId]
          })
        }
      }
    }
    var data = {data: answers};
    sendCollectedAnswers(data);
  }

  function checkAmountSelected() {
    var allInputs = $('.slick-active .response input');
    var checked = 0;
    var disabled = false;

    for (var i = 0; i < allInputs.length; i++) {
      var $response = allInputs[i];
      if ($response.checked) {
        checked++;
      }
    }

    if ((allInputs.length > 0) && (checked == 0)) {
      $('.js-next-slide').addClass('disabled');
      disabled = true;
    } else {
      $('.js-next-slide').removeClass('disabled');
      disabled = false;

    }

    var curSlideInput = $('.slick-active').find('input').length;

    if (slideCount == $('.psychoQuestions').data('length')) {
      $('.js-next-slide').text('Verzenden');
      sendAjax = true;
    } else {
      sendAjax = false;
    }

    if (!(curSlideInput > 0)) {
      $('.js-next-slide').removeClass('disabled');
      disabled = false;
      validated = true;
    }

    return disabled;
  }

  function sendCollectedAnswers(data) {
    slideCount++;
    sendAjax = false;

    $.ajax({
      method: "POST",
      url: url,
      data: JSON.stringify(data),
      dataType: "json",
      contentType: "application/json; charset=utf-8",
    })
      .done(function (msg) {
        window.location.href = survey;
      })
      .error(function (error) {
        console.error(error);
      });
  }

  return self;
})();

