<?php

namespace Bazookas\AdminBundle\Dashboard\Base;

use Bazookas\AdminBundle\Dashboard\Interfaces\DashboardElementInterface;
use Bazookas\AdminBundle\Dashboard\Interfaces\DashboardConfiguratorInterface;

/**
 * @deprecated 
 * Class BaseDashboardConfigurator
 * @package Bazookas\AdminBundle\Dashboard\Base
 */
class BaseDashboardConfigurator implements DashboardConfiguratorInterface  {
  //template layout constants
  const TEMPLATE_LAYOUT_BASIC = 'BazookasAdminBundle:Dashboard\Layout:defaultLayout.html.twig';
  const TEMPLATE_LAYOUT_CONTENT_ONLY = 'BazookasAdminBundle:Dashboard\Layout:contentOnlyLayout.html.twig';

  public $layoutTemplate;

  public $elements;

  public $title;

  /**
   * add custom styles
   * @var array
   */
  private $styles = [];

  /**
   * add custom scripts
   * @var array
   */
  private $scripts = [];

  public function __construct() {
    $this->elements = [];
    $this->layoutTemplate = self::TEMPLATE_LAYOUT_BASIC;
  }

  public function getLayoutTemplate()
  {
    return $this->layoutTemplate;
  }

  public function setLayoutTemplate($layoutTemplate)
  {
    $this->layoutTemplate = $layoutTemplate;
    return $this;
  }

  public function getElements()
  {
    return $this->elements;
  }

  public function setElements(array $elements)
  {
    $this->elements = $elements;

    return $this;
  }

  public function addElement(DashboardElementInterface $element) {
    if (!in_array($element, $this->elements)) {
      $this->elements[] = $element;
    }

    return $this;
  }

  public function removeElement(DashboardElementInterface $element) {
    if (in_array($element, $this->elements)) {
      $index = array_keys($this->elements, $element);
      unset($this->elements[$index]);
    }

    return $this;
  }

  public function getTitle()
  {
    return $this->title;
  }

  public function setTitle($title)
  {
    $this->title = $title;

    return $this;
  }

  public function getStyles()
  {
    return $this->styles;
  }

  public function setStyles($styles)
  {
    $this->styles = $styles;

    return $this;
  }

  public function getScripts()
  {
    return $this->scripts;
  }

  public function setScripts($scripts)
  {
    $this->scripts = $scripts;

    return $this;
  }

}
