<?php

namespace Bazookas\AdminBundle\Event;

use Symfony\Component\EventDispatcher\Event;
use Symfony\Component\HttpFoundation\Request;
use Bazookas\AdminBundle\Util\ListConfigurator;
use Doctrine\ORM\QueryBuilder;

/**
 * @deprecated
 *
 * Class AdminListEvent
 * @package Bazookas\AdminBundle\Event
 */
class AdminListEvent extends Event {

  function __construct($action, $id, ListConfigurator $config, $entityMetaData, $request) {
    $this->action = $action;
    $this->id = $id;
    $this->config = $config;
    $this->entityMetaData = $entityMetaData;
    $this->request = $request;
  }

  // NOTE see Bazookas/AdminBundle/README.md for more info on these events
  // LIST
  const BEFORE_LIST_QUERY = 'adminlist.before.list_query';
  const AFTER_LIST_QUERY = 'adminlist.after.list_query';
  const BEFORE_EXPORT_QUERY = 'adminlist.before.export_query';

  // EDITING
  const BEFORE_EDIT = 'adminlist.before.edit';

  // REMOVING
  const BEFORE_REMOVE_ENTITY = 'adminlist.before.remove.entity';
  const AFTER_REMOVE_ENTITY = 'adminlist.after.remove.entity';

  // PERSISTING (add or edit)
  const BEFORE_PERSIST = 'adminlist.before.persist';
  const AFTER_PERSIST = 'adminlist.after.persist';

  /**
   * @var QueryBuilder a querybuilder instance to alter
   **/
  public $queryBuilder;
  /**
   * @var array|entity array of query results or single entity
   **/
  public $queryResult;
  /**
   * @var entity single entity to be removed/persisted/...
   **/
  public $entity;
  /**
   * @var string the current page action (list|add|edit|remove)
   **/
  public $action;
  /**
   * @var int|null ID given by the request or id of newly created entity
   **/
  public $id;
  /**
   * @var ListConfigurator the configurator instance
   **/
  public $config;
  /**
   * @var ClassMetadata metadata gotten from the entity name
   **/
  public $entityMetaData;

  /**
   * @var Request the current page request
   **/
  public $request;

  public function getQueryBuilder()
  {
    return $this->queryBuilder;
  }

  public function setQueryBuilder($queryBuilder)
  {
    $this->queryBuilder = $queryBuilder;

    return $this;
  }

  public function getQueryResult()
  {
    return $this->queryResult;
  }

  public function setQueryResult($queryResult)
  {
    $this->queryResult = $queryResult;

    return $this;
  }

  public function getEntity()
  {
    return $this->entity;
  }

  public function setEntity($entity)
  {
    $this->entity = $entity;

    return $this;
  }

  public function getAction()
  {
    return $this->action;
  }

  public function setAction($action)
  {
    $this->action = $action;

    return $this;
  }

  public function getId()
  {
    return $this->id;
  }

  public function setId($id)
  {
    $this->id = $id;

    return $this;
  }

  public function getConfig()
  {
    return $this->config;
  }

  public function setConfig($config)
  {
    $this->config = $config;

    return $this;
  }

  public function getEntityMetaData()
  {
    return $this->entityMetaData;
  }

  public function setEntityMetaData($entityMetaData)
  {
    $this->entityMetaData = $entityMetaData;

    return $this;
  }

  public function getRequest()
  {
    return $this->request;
  }

  public function setRequest($request)
  {
    $this->request = $request;

    return $this;
  }

}
