<?php
namespace Bazookas\AdminBundle\Form\DataTransformer;

use Symfony\Component\Form\DataTransformerInterface;

class ArrayToStringTransformer implements DataTransformerInterface
{

    /**
     * Transforms an array to a newline separated string
     *
     * @param  array|null $array
     * @return string
     */
    public function transform($array)
    {
      $text = '';
      if (!empty($array)) {
        foreach($array as $item) {
          $text = $text.$item;
          $text = "$text\n";
        }
      }
      return $text;
    }

    /**
     * Transforms a newline separated string to an array.
     *
     * @param  string $string
     * @return array
     */
    public function reverseTransform($string)
    {
      if (empty($string)) {
        return array();
      } else {
        return explode("\n", $string);
      }
    }
}
