<?php

namespace Bazookas\AdminBundle\Form;

use FOS\UserBundle\Form\Type\RegistrationFormType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class RegistrationType extends AbstractType
{
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $builder
      ->add('name', TextType::class, [
        'label' => 'admin.registration.new.form.name'
      ])
      ->add('surname', TextType::class, [
        'label' => 'admin.registration.new.form.surname'
      ])
    ;
  }

  public function getParent()
  {
    return RegistrationFormType::class;
  }

  public function getBlockPrefix()
  {
    return 'app_user_registration';
  }

  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults([
      'translation_domain' => 'admin',
    ]);
  }
}
