<?php
// Stolen and enhanced from old bazookas admin bundles
namespace Bazookas\AdminBundle\Form\Type;

use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Bazookas\AdminBundle\Form\DataTransformer\EntityToIDTransformer;
use Doctrine\Common\Persistence\ObjectManager;
use Bazookas\AdminBundle\Util\Copy;

class HiddenEntityType extends AbstractType
{
  private $objectManager;

  public function __construct(ObjectManager $objectManager)
  {
    $this->objectManager = $objectManager;
  }


  public function getParent()
  {
    return HiddenType::class;
  }

  public function getName()
  {
    return 'hidden_entity';
  }


  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $transformer = new EntityToIDTransformer($this->objectManager, $options);
    $builder->addModelTransformer($transformer);
  }

  public function buildView(FormView $view, FormInterface $form, array $options)
  {
  }

  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults(array(
      'class' => null,
      'translation_domain' => 'admin'
    ));
  }
}
