# Bazookas AdminBundle

This bundle contains code for creating admin lists. Forms and access control functionality is also provided by this bundle.

## Getting Started

* [Installation](Resources/docs//General/installation.md)

## v2 Components
### Getting started

- [Creating a basic list controller](Resources/docs/Components/Admin/GettingStarted/basicListController.md)
- [Modifying page builders](Resources/docs/Components/Admin/GettingStarted/modifyPageBuilders.md)
- [Creating a basic dashboard](Resources/docs/Components/Admin/GettingStarted/basicDashboard.md)
- [Adding menu items](Resources/docs/Components/Admin/GettingStarted/addingMenuItems.md)
- [Showing custom CMS exceptions](Resources/docs/Components/Admin/ExtraFunctionality/customExceptions.md)

### Understanding core concepts

- [The controller hierarchy](Resources/docs/Components/Admin/CoreConcepts/controllers.md)
- [Page builders hierarchy](Resources/docs/Components/Admin/CoreConcepts/pageBuilders.md) //TODO write it!
- [Admin elements](Resources/docs/Components/AdminElements/index.md)

### Including extra functionality
#### List-table functionality
- [Adding filtering](Resources/docs/Components/Admin/ExtraFunctionality/filters.md)

#### Exporting data
- [Export bundle integration](https://github.com/Bazookastudios/BazookasExportBundle)

#### Notifications
- [Adding notifications](Resources/docs/Components/Admin/ExtraFunctionality/notifications.md)

#### Forms
- [Form grouping](Resources/docs/Components/Admin/Advanced/formGrouping.md)

### Advanced scenarios
- [Creating and using a custom CMS user](Resources/docs/Components/Admin/Advanced/customCmsUser.md)
- [Enabling registration for CMSUsers](Resources/docs/Components/Admin/ExtraFunctionality/cmsUserRegistration.md))


## v1 Components
### Form
* [Forms](Resources/docs/Components/Form/index.md)

### Admin pages
* [Admin lists](Resources/docs/Components/AdminList/adminList.md)
* [Dashboard](Resources/docs/Components/Dashboard/index.md)

### Exports
* [Export service](Resources/docs/Components/ExportService/exportService.md)

### Auditing
* [Auditing functionality](Resources/docs/Components/Audit/index.md)

### Testing
* [Testing for a better tomorrow](Resources/docs/Testing/index.md)

### Menu config
* [Menu configuration](Resources/docs/General/menu.md)
