<?php

namespace Bazookas\AdminBundle\Repository\Base;

use Bazookas\AdminBundle\Entity\Interfaces\Notification\EmailNotificationInterface;
use Bazookas\AdminBundle\Repository\Interfaces\Notification\EmailNotificationRepositoryInterface;
use Doctrine\ORM\Query;

class BaseEmailNotificationRepository extends BaseNotificationRepository implements EmailNotificationRepositoryInterface
{

  /**
   * @param int $hydrationMode
   * @return EmailNotificationInterface[]
   */
  public function getAllNotifications($hydrationMode = Query::HYDRATE_ARRAY) {
    $qb = $this->_em->createQueryBuilder();
    $qb
      ->select('notifications, user')
      ->from($this->_entityName, 'notifications')
      ->leftJoin('notifications.user', 'user')
    ;

    return $qb->getQuery()->getResult($hydrationMode);
  }

  /**
   * @param array $ids
   */
  public function removeNotifications(array $ids) {
    $qb = $this->_em->createQueryBuilder();
    $qb
      ->delete($this->_entityName, 'notifications')
      ->andWhere($qb->expr()->in('notifications.id', ':ids'))
      ->andWhere($qb->expr()->isNotNull('notifications.link'))
      ->setParameter('ids', $ids)
    ;

    $qb->getQuery()->execute();
  }

}
