<?php

namespace Bazookas\AdminBundle\Repository\Interfaces;

use Bazookas\AdminBundle\Entity\CMSUser;
use Doctrine\ORM\Query;

interface CMSUserRepositoryInterface
{

  /**
   * Get all roles and all inherited roles for a given cms user
   * @param CMSUser $user
   * @param array $roleHierarchy an instance of "%security.role_hierarchy.roles%"
   * @return array
   */
  public function getRolesForUser(CMSUser $user, array $roleHierarchy);

  /**
   * Get all of the users who have the given roles. Use the $conditionType parameter to indicate if the user should
   * be returned if they have one or more of the roles, or if they have all of the roles.
   * @param array $roles
   * @param int $hydrationMode
   * @param string $conditionType
   * @return array|CMSUser[]
   */
  public function getUsersByRoles(array $roles, $hydrationMode = Query::HYDRATE_ARRAY, $conditionType = 'OR');

}
