<?php

namespace Bazookas\APIFrameworkBundle;

use Symfony\Component\HttpKernel\Bundle\Bundle;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Bazookas\APIFrameworkBundle\DependencyInjection\Compiler\UserProviderPass;
use Bazookas\APIFrameworkBundle\DependencyInjection\Compiler\DataServicePass;

//classes to compile
use Bazookas\APIFrameworkBundle\Controller\Base\BaseController;
use Bazookas\APIFrameworkBundle\Exception\Base\BaseApiException;
use Bazookas\APIFrameworkBundle\Exception\Interfaces\ApiExceptionInterface;
use Bazookas\APIFrameworkBundle\Exception\ApiException;
use Bazookas\APIFrameworkBundle\Exception\ElementNotFoundException;
use Bazookas\APIFrameworkBundle\Exception\InvalidArgumentException;
use Bazookas\APIFrameworkBundle\Security\OAuth\GrantTypeExtensions\FacebookOAuthGrantExtension;
use Bazookas\APIFrameworkBundle\Services\Validation\ValidationService;
use Bazookas\APIFrameworkBundle\Services\Data\DataServiceChain;

class BazookasAPIFrameworkBundle extends Bundle
{
  public function build(ContainerBuilder $container) {
    $container->addCompilerPass(new UserProviderPass());
    $container->addCompilerPass(new DataServicePass());
  }

  public function load(array $configs, ContainerBuilder $container)
  {
     $this->addClassesToCompile(array(
        BaseController::class,
        BaseApiException::class,
        ApiExceptionInterface::class,
        ApiException::class,
        ElementNotFoundException::class,
        InvalidArgumentException::class,
        FacebookOAuthGrantExtension::class,
        ValidationService::class,
        DataServiceChain::class
    ));
  }
}
