<?php

namespace Bazookas\APIFrameworkBundle\Controller\Admin;

use Bazookas\AdminBundle\Controller\Base\BaseAdminListController;
use Bazookas\AdminBundle\PageBuilder\Interfaces\ListPageBuilderInterface;
use Bazookas\AdminBundle\PageBuilder\ListPageBuilder;
use Bazookas\APIFrameworkBundle\Form\AppCopyAdminType;
use Bazookas\CommonBundle\Security\Roles;
use Symfony\Component\HttpFoundation\Request;

class AppCopyAdminController extends BaseAdminListController
{
  /**
   * @return string the entity fully qualified class name
   */
  protected function getEntityClass()
  {
    return $this->getParameter('bazookas_api_framework.app_copy.entity');
  }

  /**
   * @param $action
   * @return string the fully qualified class name of the form
   */
  protected function getFormClass($action)
  {
    return AppCopyAdminType::class;
  }

  protected function modifyListBuilder(Request $request, ListPageBuilderInterface $builder)
  {
    /** @var ListPageBuilder $builder */
    $builder = parent::modifyListBuilder($request, $builder);

    $builder
      ->addField('key', [
        'label' => 'admin.entities.appCopy.fields.key',
      ])
      ->addField('details', [
        'label' => 'admin.entities.appCopy.fields.details',
        'template' => 'BazookasAPIFrameworkBundle:List//Fields:_appCopyDetails.html.twig',
      ])
      ->addTextFilterField('key')
      ->addTextFilterField('details.value')
    ;

    return $builder;
  }

  protected function hasAccess($action) {
    switch($action) {
      case self::ACTION_ADD:
      case self::ACTION_LIST:
      case self::ACTION_EDIT:
      case self::ACTION_REMOVE:
        return $this->isGranted(Roles::ROLE_SUPER_ADMIN);
      default:
        return false;
    }
  }

}
