<?php

namespace Bazookas\APIFrameworkBundle\Controller\Admin;

use Bazookas\AdminBundle\Controller\Base\BaseAdminListController;
use Bazookas\AdminBundle\PageBuilder\Interfaces\ListPageBuilderInterface;
use Bazookas\AdminBundle\PageBuilder\ListPageBuilder;
use Bazookas\APIFrameworkBundle\Form\AppSettingsAdminType;
use Bazookas\CommonBundle\Security\Roles;
use Symfony\Component\HttpFoundation\Request;


class AppSettingsAdminController extends BaseAdminListController
{
  /**
   * @return string the entity fully qualified class name
   */
  protected function getEntityClass()
  {
    return $this->getParameter('bazookas_api_framework.app_settings.entity');
  }

  /**
   * @param $action
   * @return string the fully qualified class name of the form
   */
  protected function getFormClass($action)
  {
    return AppSettingsAdminType::class;
  }

  protected function modifyListBuilder(Request $request, ListPageBuilderInterface $builder)
  {
    /** @var ListPageBuilder $builder */
    $builder = parent::modifyListBuilder($request, $builder);

    $builder
      // TODO type is for future use
//      ->addField('type', [
//        'label' => 'admin.entities.appSettings.fields.type',
//      ])
      ->addField('key', [
        'label' => 'admin.entities.appSettings.fields.key',
      ])
      ->addField('setting', [
        'label' => 'admin.entities.appSettings.fields.setting',
      ])
      //TODO type is for future use!
//      ->addTextFilterField('type')
      ->addTextFilterField('key')
      ->addTextFilterField('setting')
    ;

    return $builder;
  }

  protected function hasAccess($action) {
    switch($action) {
      case self::ACTION_ADD:
      case self::ACTION_LIST:
      case self::ACTION_EDIT:
      case self::ACTION_REMOVE:
        return $this->isGranted(Roles::ROLE_SUPER_ADMIN);
      default:
        return false;
    }
  }
}
