<?php

namespace Bazookas\APIFrameworkBundle\Entity\Base;

use Bazookas\CommonBundle\Entity\Base\BaseEntity;
use Bazookas\CommonBundle\Entity\Interfaces\EntityDetailParentInterface;
use Bazookas\CommonBundle\Entity\Traits\DetailParentTrait;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

class BaseAppCopy extends BaseEntity implements EntityDetailParentInterface {
  use DetailParentTrait;

  /**
   * NO! Don't add an id named "id", use key instead
   */
  protected $id;

  /**
   * An id without auto generated value
   * @ORM\Id
   * @ORM\Column(type="string", name="key_string")
   * @Assert\NotBlank
   */
  protected $key;

  /**
   * @var ArrayCollection<BaseAppCopyDetail>
   * override this in extending class to add the relation
   * assertions are inherited, yo! This is awesome
   * @Assert\Valid
   */
  protected $details;

  public function __construct()
  {
    parent::__construct();
    $this->details = new ArrayCollection();
  }

  public function getKey()
  {
    return $this->key;
  }

  public function setKey($key)
  {
    $this->key = $key;
    return $this;
  }

  /**
   * @return mixed $key to make entity action buttons work
   */
  public function getId() {
    return $this->getKey();
  }
}
