<?php
namespace Bazookas\APIFrameworkBundle\Exception;

use Bazookas\APIFrameworkBundle\Exception\Base\ApiExceptionMap;
use Exception;
use Bazookas\APIFrameworkBundle\Exception\Base\BaseApiException;
use Bazookas\CommonBundle\Services\Exception\Interfaces\LoggableExceptionInterface;
use Symfony\Component\HttpFoundation\Response;

class ElementNotFoundException extends BaseApiException {

  public function __construct($message, $name = ApiExceptionMap::NOT_FOUND, $statusCode = Response::HTTP_NOT_FOUND, Exception $previous = null) {
    parent::__construct($message, $name, $statusCode, $previous);
  }

  /**
   * @inheritdoc
   */
  public function getLoggingSeverity() {
    return LoggableExceptionInterface::PRIORITY_ERROR;
  }

}
