# Bazookas GeneratorBundle

This bundle allows one to generate an admin controller and associated form, use the following command to generate:

## Installing
### With composer
Add the following to composer.json (composer will ask authentication for private bundles the first time you install a bazookas bundle)
```json
    "repositories": [
        {
            "type": "vcs",
            "url": "https://github.com/Bazookastudios/BazookasGeneratorBundle.git"
        }
    ],
```

And then: `composer require bazookas/generator-bundle`

### As a git submodule
Use this command in the root of your repository to add this bundle as a submodule.

```bash
git submodule add -b master --name GeneratorBundle https://github.com/Bazookastudios/BazookasGeneratorBundle.git ./src/Bazookas/GeneratorBundle
```
## Activating the installation

### Activate in AppKernel.php

```php
      new Bazookas\GeneratorBundle\BazookasGeneratorBundle(),
```

## Generator commands

### AdminController
This bundle allows to generate an admin controller and associated form, use the following command to generate:

`php bin/console bazookas:generate:admin-controller --entity=EntityBundle:AppSettings --controller=MobilefansBundle:AppSettings --route=appsettings`

Options:
- entity: the name shortcut name of the entity to generate an admin controller for
- controller: shortcutname of the controller to generate
- route: the route to associate with the controller

### Create entity instance

`php bin/console bazookas:create:entity-instance --entity-class=APIBundle:AppUser`

A wizard will show up for filling in the entity details.
