<?php
namespace Bazookas\IntegrationsBundle\Exception;

use Exception;
use Bazookas\IntegrationsBundle\Exception\Base\BaseIntegrationException;
use Bazookas\CommonBundle\Services\Exception\Interfaces\LoggableExceptionInterface;
use Symfony\Component\HttpFoundation\Response;

class FacebookIntegrationException extends BaseIntegrationException
{
  private $loggable = true;

  // Redefine the exception so message isn't optional
  public function __construct($message, $name = IntegrationsExceptionMap::FACEBOOK_INTEGRATION_EXCEPTION, $statusCode = Response::HTTP_INTERNAL_SERVER_ERROR, Exception $previous = null) {
    $this->message = $message;
    $this->name = $name;
    $this->statusCode = $statusCode;

    // make sure everything is assigned properly
    parent::__construct($message, 0, $previous);
  }

  public function getIntegration() {
    return 'Facebook';
  }

  public function getLoggingSeverity() {
    return LoggableExceptionInterface::PRIORITY_CRITICAL;
  }
}
