<?php

namespace Bazookas\MediaBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Bazookas\AdminBundle\Controller\ListBaseController;
use Bazookas\AdminBundle\Util\ListConfigurator;
use WebsiteBundle\Form\MenuAdminType;

class MediaVideoProviderAdminController extends ListBaseController
{

  function __construct() {
    // make sure parent construct is called!
    parent::__construct();

    $this->config->entity = 'BazookasMediaBundle:VideoProvider';
    $this->config->entityName = 'media.entities.videoProvider.name';
    // $this->config->addField('property', 'table-header', 'sortable', 'td class', 'template');

    //TODO create a custom list view

    $this->config->addField('provider', 'media.entities.videoProvider.fields.provider');
    $this->config->addField('accessToken', 'media.entities.videoProvider.fields.accessToken');

    $this->config->setForm('Bazookas\MediaBundle\Form\VideoProviderType');
  }

  protected function checkAccess($_action, $_id) {
    // when returning false on any action, there is no real need to set these
    // these are only usefull for showing/hiding the buttons
    $this->config->setAccess('add', false);
    // $this->config->setAccess('edit', false);
    $this->config->setAccess('remove', false);
    return $this->isGranted('ROLE_ADMIN');
  }

}
