<?php

namespace Bazookas\MediaBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Bazookas\MediaBundle\Form\BaseMediaType;
use Bazookas\MediaBundle\Entity\Image;
use Symfony\Component\Form\Extension\Core\Type\FileType;
use Bazookas\AdminBundle\Form\Type\ImagePreviewType;

class ImageMediaType extends AbstractType
{

  /**
  * @param FormBuilderInterface $builder
  * @param array $options
  */
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $builder
      ->add('baseMedia', BaseMediaType::class, array(
        'data_class' => Image::class,
        'label' => false
      ))
      ->add('relativeUrl', ImagePreviewType::class, array(
        'label' => false,
        'required' => false,
        'previewFileInput' => '#image_media_file',
      ))
      ->add('file', FileType::class, array(
        'label' => 'media.entities.image.fields.file',
        'required' => false,
        'compound' => false,
      ))
    ;
  }

  /**
  * @param OptionsResolver $resolver
  */
  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults(array(
      'data_class' => 'Bazookas\MediaBundle\Entity\Image'
    ));
  }

}
