<?php

namespace Bazookas\MediaBundle\Services\Media\Video;

use Bazookas\MediaBundle\Services\Media\Video\Interfaces\VideoServiceInterface;
use Doctrine\Common\Collections\ArrayCollection;

class VideoServiceChain {

  private $videoServices;

  public function __construct() {
    $this->videoServices = new ArrayCollection();
  }

  public function getVideoServices() {
    return $this->videoServices;
  }

  public function setVideoServices($videoServices) {
    if (is_array($videoServices)) {
      $videoServices = new ArrayCollection($videoServices);
    }

    $this->videoServices = $videoServices;
  }

  public function addVideoService(VideoServiceInterface $videoService) {
    if (!$this->videoServices->contains($videoService)) {
      $this->videoServices->add($videoService);
    }
  }

  public function removeVideoService(VideoServiceInterface $videoService) {
    $this->videoServices->removeElement($videoService);
  }

}
